<?php

/**
*
* Module for booklibrary
 * @version 1.5
 * @package Booklibrary
* @copyright 2009 Andrey Kvasnevskiy-OrdaSoft(akbet@mail.ru); Rob de Cleen(rob@decleen.com); 
* Homepage: http://www.ordasoft.com
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*
**/

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Restricted access' );
$database = &JFactory::getDBO();


if( !function_exists( 'sefreltoabs')) {
  function sefRelToAbs( $value ) {
    //Need check!!!

    // Replace all &amp; with & as the router doesn't understand &amp;
    $url = str_replace('&amp;', '&', $value);
    if(substr(strtolower($url),0,9) != "index.php") return $url;
    $uri    = JURI::getInstance();
    $prefix = $uri->toString(array('scheme', 'host', 'port'));
    return $prefix.JRoute::_($url);
  }
}

//Carls Edit For Params

if (is_callable(array($params,"get"))) {				// Mambo 4.5.0 compatibility
	$show_covers 	= $params->def('covers', 0 ); 			//Get if we show covers
	$cover_height	= $params->def('cover_height', "50"); 	//Get Cover Height 
	$show_extra		= $params->def('extras', 1 ); 			//Get if we show second column with additional info
	$show_ranking	= $params->def('ranking', 0 ); 			//Get if we show the ranking next to them
	$show_this_many	= $params->def('top_number', "10"); 	//Get how many top books to show
	$sort_top_by	= $params->def('sort_by_top', 0);		//Get how to sort the top items
	$show_published	= $params->def('only_published', 1);	//Get if we only show published items
} else {	//Set Defaults If nothing set
	$show_covers	= 0;
	$cover_height	= "50";	
	$show_extra		= 1;
	$show_ranking	= 0;
	$show_this_many	= "10";
	$sort_top_by	= 0;
	$show_published = 1;
}

//Check if only display published items
If ($show_published==1) {
	$sql_published = "WHERE published=1 ";
} else {
	$sql_published = "";
}

//Definition of Sorts
switch($sort_top_by) 
{
	case 0:
		$sql_sort_top = "hits";
		break;
	case 1:
		$sql_sort_top = "date";
		break;
	case 2:
		$sql_sort_top = "rating";
		break;
}	 

$rank_count = 0; //Set Initial Rank Count

//End Carls Edit

$selectstring = "SELECT * FROM #__booklibrary AS a ".$sql_published.
				"\nORDER BY ".$sql_sort_top." DESC LIMIT 0,". $show_this_many .";";

$database->setQuery($selectstring);
$rows = $database->loadObjectList();

$selectstring = "SELECT id FROM #__menu WHERE link='index.php?option=com_booklibrary'";
$database->setQuery($selectstring);
$ItemId_tmp = $database->loadResult();

//todo load correct itemid
?>
<table cellpadding="0" cellspacing="0" class="moduletable" width="100%">
   <tr>
      <td>
         <table cellpadding="0" cellspacing="0" class="moduletable" width="100%">
	<?php foreach ($rows as $row) { 
	$rank_count = $rank_count + 1;	//start ranking
	$link1 = "index.php?option=com_booklibrary&amp;task=view&amp;id=".$row->id."&amp;Itemid=".$ItemId_tmp."&amp;catid=".$row->catid; //Carls Edit for SEF this is the actual link structure that is then called using sefRelToAbs to create SEF url.
	?>
		<tr>
        			 <?php if($show_ranking==1) { echo "<td>".$rank_count.":&nbsp;</td>"; } //Add Column for Ranking if param set ?>
                     <?php if ($show_covers==1) {?><td><img src="<?php echo $row->imageURL; ?>" alt="<?php echo $row->title; ?>" hspace="2" vspace="2" border="0" height="<?php echo $cover_height; ?>" /></td><?php } //End Show Covers If?>
                     <td style="vertical-align:middle">
                     <a href="<?php echo sefRelToAbs($link1); ?>">
					 	<?php echo $row->title; ?></a>
                     </td>
		   <?php if($show_extra==1) {?>
           <td align="right">
                     <font class='small'>(<?php echo $row->hits; ?>)</font>
		   </td>
           <?php } //End Show Extra If?>
                  </tr>
           <?php } ?>
           </table>
      </td>
   </tr>
</table>
